#2011, Eulalie Sauthier, Master Thesis


cercle_corr_zones <- function(input_data, nbstation , filename,dbt,dbt_j,fin,fin_j,fq) {

pca<-prcomp(na.omit(input_data),center=TRUE, scale= TRUE) #effectue l'analyse en composantes principales
prop_var<-round(((pca$sdev^2) / sum(pca$sdev^2))*100,2) #calcul la variance des axes
prop_var_2<- prop_var[1]+prop_var[2]  #pour afficher la somme des deux axes sur le graphe 

cercle<-matrix(nrow= nbstation, ncol= nbstation)

for (i in 1: nbstation)
cercle[ ,i]<- pca$rotation[ ,i]* pca$sdev[i] #calcule les cordonées des flèche de corrélation
#plot le cercle de corrélation
a <- seq(0,2*pi,length=100) #coefficient du cercle

meuhx<-c(-1,-0.75,-0.5,0.0,0.5,0.75,1.0) #place les axes 0
meuhy<-c(0,0,0,0,0,0,0) #place les axes 0
name<-paste("../Image/Correlation_cercle",filename,".pdf") #nom pour sauver l'image en pdf
name_title<-paste("Cercle de correlation",filename,"(", prop_var_2,"%)")#nom pour le titre de l'image
name_x<-paste("F1 - (", prop_var[1],"%)") #nom pour l'axe x
name_y<-paste("F2 - (", prop_var[2],"%)") #nom pour l'axe y

pdf(name) #sauver l'image
plot( cos(a), sin(a), 
      type = 'l', lty = 3,
      xlab = name_x, ylab =name_y, 
      main = name_title) #plot le cercle

lines(meuhx,meuhy, pch=22, lty=2, col="black") #ajoute l'axe x et y
lines(meuhy,meuhx, pch=22, lty=2, col="black")

v <- t(cercle)[1:2, ] 
arrows(0,0, v[1,], v[2,], col='red') #plot les dlèches
text(v[1,], v[2,],row.names(pca$rotation)) #ajoute le texte aux flèches
dev.off() #ferme l'image en pdf
scores<-pca$x #récupère les scores
z <- ts(cumsum(scores), start=c(dbt, dbt_j),end=c(fin,fin_j), frequency=fq) #transforme les scores en série temporel
return(z)#retourne les scores en séries temporelles
}